package com.azias.vendingmachine;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraftforge.common.MinecraftForge;

import java.util.Arrays;

import com.azias.vendingmachine.blocks.VendingMachineBlocks;
import com.azias.vendingmachine.items.VendingMachineItems;

import cpw.mods.fml.common.FMLCommonHandler;
import cpw.mods.fml.common.Mod;
import cpw.mods.fml.common.Mod.EventHandler;
import cpw.mods.fml.common.ModMetadata;
import cpw.mods.fml.common.event.FMLInitializationEvent;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;

@Mod(modid = VendingMachineMod.MODID, version = VendingMachineMod.VERSION, name = VendingMachineMod.MODNAME)
public class VendingMachineMod {
	private static VendingMachineEvents modEvents = new VendingMachineEvents();
    public static final String MODID = "aziasvendingmachine";
    public static final String MODNAME = "Vending Machines Revamped";
    public static final String VERSION = "0.30";
	public static String VERSIONOFFICIAL;
    public static CreativeTabs tabVendingMachines = new VendingMachineCreativeTab("VendingMachines");
    
    @EventHandler
    public static void PreLoad(FMLPreInitializationEvent preEvent) {
		FMLCommonHandler.instance().bus().register(modEvents);
		MinecraftForge.EVENT_BUS.register(modEvents);
		VendingMachineConfigs.loadConfigurationFile(preEvent);
		VendingMachineEvents.getOfficialVersionNumber();
		
    	VendingMachineBlocks.registerBlocks(preEvent);
    	VendingMachineItems.registerItems(preEvent);
    	VendingMachineRecipes.registerRecipes();
    	
		ModMetadata modmeta = preEvent.getModMetadata();
		modmeta.version = VERSION;
		modmeta.url = "http://minecraft.curseforge.com/mc-mods/233580-vending-machines-revamped";
		modmeta.updateUrl = "http://minecraft.curseforge.com/mc-mods/233580-vending-machines-revamped";
		modmeta.name = MODNAME;
		modmeta.authorList = Arrays.asList(new String[] { "Azias" });
		modmeta.description = "Adds vending machines, soda, coffee and more to your game.";
		modmeta.credits = "angrybeast96, MrArcane111, general3214, LockRikard";
		modmeta.logoFile = "vendingLogo.png";
		modmeta.autogenerated = false;
    }
    
    @EventHandler
    public void init(FMLInitializationEvent event) {
    	
    }
}
